/** -------------------------------------------------- 
* Hochschule fr Technik Stuttgart 
* Fachbereich Vermessung , Informatik und Mathematik 
* Schellingstr . 24 
* D - 70174 Stuttgart 
* 
* Projekt CityDoktor 
* 
* Copyright (c) 2011 HFT Stuttgart. All rights reserved. 
* HFT Stuttgart and its licensors retain all intellectual property and 
* proprietary rights in and to this software and related documentation. 
* Any use, reproduction, disclosure, or distribution of this software 
* and related documentation without an express license agreement from 
* HFT Stuttgart is strictly prohibited. 
* 
* Please refer to the applicable HFT Stuttgart end user license agreement (EULA) 
* associated with this source code for terms and conditions that govern 
* your use of this HFT Stuttgart software. 
* 
* @author alam
* @version 1.0
* created: 14.09.2011
*/
package de.hft.stuttgart.graphtheory;

import java.util.ArrayList;
import java.util.List;

public class GraphEdge {
	
	private List<Integer> vertices = new ArrayList<>(); 
	/**
	 * first node of the graph edge.
	 */
	private GraphNode node1;
	/**
	 * second node of the graph edge.
	 */
	private GraphNode node2;
	/**
	 * Getter of the property <tt>node1</tt>
	 * @return the node1
	 * @uml.property name = "node1"
	 */
	public GraphNode getNode1() {
		return node1;
	}
	/**
	 * Setter of the property <tt>node1</tt>
	 * @param node1 the node1 to set
	 * @uml.property name = "node1"
	 */
	public void setNode1(GraphNode node1) {
		this.node1 = node1;
	}
	/**
	 * Getter of the property <tt>node2</tt>
	 * @return the node2
	 * @uml.property name = "node2"
	 */
	public GraphNode getNode2() {
		return node2;
	}
	/**
	 * Setter of the property <tt>node2</tt>
	 * @param node2 the node2 to set
	 * @uml.property name = "node2"
	 */
	public void setNode2(GraphNode node2) {
		this.node2 = node2;
	}
	/**
	 * @return the vertices
	 */
	public List<Integer> getVertices() {
		return vertices;
	}
	/**
	 * @param vertices the vertices to set
	 */
	public void setVertices(List<Integer> vertices) {
		this.vertices = vertices;
	}
	/**
	 * Check if the node exists in the edge.
	 * @param node which is being searched.
	 * @return true if exists and false if not.
	 */
	public boolean checkIfNodeExists(GraphNode node){
		if(node.getNode().equals(node1.getNode())||node.getNode().equals(node2.getNode())){
			return true;
		}else return false;
//		if(node.getNode()==node1.getNode()||node.getNode()==node2.getNode()){
//			return true;
//		}else return false;
	}
	public boolean checkIfBothNodesExist(GraphNode a,GraphNode b){
//		System.out.println(a.getNode()+" + "+b.getNode()+" + "+ node1.getNode()+" + "+ node2.getNode());
		if((a.getNode().equals(node1.getNode()) && b.getNode().equals(node2.getNode()))||
				(a.getNode().equals(node2.getNode()) && b.getNode().equals(node1.getNode()))){
//			System.out.println("<<<<<<<<<<<<<<<found>>>>>>>>>>>>>>>");
			return true;
		}else return false;
		
//		if((a.getNode()==node1.getNode() && b.getNode()==node2.getNode())||
//				(a.getNode()==node2.getNode() && b.getNode()==node1.getNode())){
//			System.out.println("<<<<<<<<<<<<<<<found>>>>>>>>>>>>>>>");
//			return true;
//		}else return false;
	}
	/**
	 * Check if the target edge is equal to the current edge
	 * @param e target edge
	 * @return true if equal and false if not.
	 */
	public boolean CheckIfEqual(GraphEdge e){
		if ((e.getNode1().getNode().equals(this.node1.getNode())&&(e.getNode2().getNode().equals(this.node2.getNode())))||
				(e.getNode1().getNode().equals(this.node2.getNode())&&(e.getNode2().getNode().equals(this.node1.getNode())))){
			return true;
		}else return false;
//		if ((e.getNode1().getNode()==this.node1.getNode() && e.getNode2().getNode()==this.node2.getNode())||
//				(e.getNode1().getNode()==this.node2.getNode() && e.getNode2().getNode()==this.node1.getNode())){
//			return true;
//		}else return false;
	}
	/**
	 * Check if the target edge is exactly same as the current edge
	 * @param e target edge
	 * @return true if exactly same and false if not.
	 */
	public boolean CheckIfExactlySame(GraphEdge e){
		if (e.getNode1().getNode().equals(this.node1.getNode())&&(e.getNode2().getNode().equals(this.node2.getNode()))){
			return true;
		}else return false;
//		if (e.getNode1().getNode()==this.node1.getNode() && e.getNode2().getNode()==this.node2.getNode()){
//			return true;
//		}else return false;
	}
}
