/** -------------------------------------------------- 
* Hochschule fr Technik Stuttgart 
* Fachbereich Vermessung , Informatik und Mathematik 
* Schellingstr . 24 
* D - 70174 Stuttgart 
* 
* Projekt CityDoktor 
* 
* Copyright (c) 2011 HFT Stuttgart. All rights reserved. 
* HFT Stuttgart and its licensors retain all intellectual property and 
* proprietary rights in and to this software and related documentation. 
* Any use, reproduction, disclosure, or distribution of this software 
* and related documentation without an express license agreement from 
* HFT Stuttgart is strictly prohibited. 
* 
* Please refer to the applicable HFT Stuttgart end user license agreement (EULA) 
* associated with this source code for terms and conditions that govern 
* your use of this HFT Stuttgart software. 
* 
* @author alam
* @version 1.0
* created: Nov 14, 2011
*/
package de.hft.stuttgart.graphtheory;

import java.util.ArrayList;
import java.util.List;




/**
 * @author alam
 *
 */
public class GraphNode {
	
	
	/**
	 * Constructor
	 */
	public GraphNode(){
		marked = false;
		node = new Object();
		status = GRAPHSTATUS.NOT_STARTED_YET;
		adjucentNodes = new ArrayList<GraphNode>();
	}
	
	/**
	 * Constructor
	 */
	public GraphNode(int id){
		marked = false;
		node = new Object();
		status = GRAPHSTATUS.NOT_STARTED_YET;
		adjucentNodes = new ArrayList<GraphNode>();
		this.id=id;
	}
	
	public int id;
	
	
	/**
	 * 
	 */
	private boolean marked;
	/**
	 * original object which is marked as node of the graph
	 */
	private Object node;
	/**
	 * status of the node.
	 */
	public enum GRAPHSTATUS {
		NOT_STARTED_YET, IN_PROGRESS, DONE
	} 
	private GRAPHSTATUS status;
	/**
	 * list of adjecent nodes.
	 */
	private List<GraphNode> adjucentNodes;
	/**
	 * Getter of the property <tt>node</tt>
	 * @return the node
	 * @uml.property name = "node"
	 */
	public Object getNode() {
		return node;
	}
	/**
	 * Setter of the property <tt>node</tt>
	 * @param node the node to set
	 * @uml.property name = "node"
	 */
	public void setNode(Object node) {
		this.node = node;
	}
	/**
	 * Getter of the property <tt>status</tt>
	 * @return the status
	 * @uml.property name = "status"
	 */
	public GRAPHSTATUS getStatus() {
		return status;
	}
	/**
	 * Setter of the property <tt>status</tt>
	 * @param status the status to set
	 * @uml.property name = "status"
	 */
	public void setStatus(GRAPHSTATUS status) {
		this.status = status;
	}
	/**
	 * Getter of the property <tt>adjucentNodes</tt>
	 * @return the adjucentNodes
	 * @uml.property name = "adjucentNodes"
	 */
	public List<GraphNode> getAdjucentNodes() {
		return adjucentNodes;
	}
	/**
	 * Setter of the property <tt>adjucentNodes</tt>
	 * @param adjucentNodes the adjucentNodes to set
	 * @uml.property name = "adjucentNodes"
	 */
	public void setAdjucentNodes(List<GraphNode> adjucentNodes) {
		this.adjucentNodes = adjucentNodes;
	}
	/**
	 * Getter of the property <tt>marked</tt>
	 * @return the marked
	 * @uml.property name = "marked"
	 */
	public boolean isMarked() {
		return marked;
	}
	/**
	 * Setter of the property <tt>marked</tt>
	 * @param marked the marked to set
	 * @uml.property name = "marked"
	 */
	public void setMarked(boolean marked) {
		this.marked = marked;
	}

	
}
