/** -------------------------------------------------- 
* Hochschule f�r Technik Stuttgart 
* Fachbereich Vermessung , Informatik und Mathematik 
* Schellingstr . 24 
* D - 70174 Stuttgart 
* 
* Projekt CityDoktor 
* 
* Copyright (c) 2011 HFT Stuttgart. All rights reserved. 
* HFT Stuttgart and its licensors retain all intellectual property and 
* proprietary rights in and to this software and related documentation. 
* Any use, reproduction, disclosure, or distribution of this software 
* and related documentation without an express license agreement from 
* HFT Stuttgart is strictly prohibited. 
* 
* Please refer to the applicable HFT Stuttgart end user license agreement (EULA) 
* associated with this source code for terms and conditions that govern 
* your use of this HFT Stuttgart software. 
* 
* @author 
* @version 
* 
*/


package de.hft.stuttgart.linearalgebra;

import java.util.ArrayList;
import java.util.List;


public class CheckLineLineIntersection {

	private static List<double[]> intersection =  new ArrayList<double[]>();
	private static double[] overlap = null;
	/**
	 * Constructor
	 */
	public CheckLineLineIntersection(){
		
	}
	/**
	 * Check if two line intersects each other
	 * @param a1 1st vertex of line one
	 * @param a2 2nd vertex of line one
	 * @param b1 1st vertex of line two
	 * @param b2 2nd vertex of line two
	 * @return true if intersects
	 */
	public static boolean checkIntersection(double[] a1, double[] a2, double[] b1, double[] b2){
		boolean Intersection=false;
		double 	x1,y1,z1,
				x2,y2,z2,
				x3,y3,z3,
				x4,y4,z4;
		intersection =  new ArrayList<double[]>();overlap = null;
//		if(a1==null||a2==null||b1==null||b2==null)return false;
		x1=a1[0];x2=a2[0];x3=b1[0];x4=b2[0];
		y1=a1[1];y2=a2[1];y3=b1[1];y4=b2[1];
		z1=a1[2];z2=a2[2];z3=b1[2];z4=b2[2];
		if((Compare.ifEqual(x1, x3) && Compare.ifEqual(y1, y3) && Compare.ifEqual(z1, z3))||
				(Compare.ifEqual(x1, x4) && Compare.ifEqual(y1, y4) && Compare.ifEqual(z1, z4))||
				(Compare.ifEqual(x2, x3) && Compare.ifEqual(y2, y3) && Compare.ifEqual(z2, z3))||
				(Compare.ifEqual(x4, x3) && Compare.ifEqual(y4, y3) && Compare.ifEqual(z4, z3))){
			Intersection=  checkOverLap(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4);
			if(overlap !=null) {
				intersection.add(overlap);
				return true;
			}else return false;
		}
		if((Compare.ifEqual((x2-x1),(x4-x3))&&Compare.ifEqual((y2-y1),(y4-y3))&&Compare.ifEqual((z2-z1),(z4-z3)))||
				(Compare.ifEqual((x2-x1),(-(x4-x3)))&&Compare.ifEqual((y2-y1),(-(y4-y3)))&&Compare.ifEqual((z2-z1),(-(z4-z3))))){
//			parallel because direction vector same
			Intersection=checkOverLap(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4);
			return Intersection;
		}else if (Compare.ifEqual(((x2-x1)/(x4-x3)),((y2-y1)/(y4-y3)))&&
				Compare.ifEqual(((y2-y1)/(y4-y3)),((z2-z1)/(z4-z3)))&&
				Compare.ifEqual(((z2-z1)/(z4-z3)),((x2-x1)/(x4-x3)))){
//			two lines are parallel
			Intersection=checkOverLap(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4);
			return Intersection;
		}else if((Compare.ifEqual(x2,x1)&&Compare.ifEqual(x4,x3)&&!Compare.ifEqual(x2,x3))||
				(Compare.ifEqual(y2,y1)&&Compare.ifEqual(y4,y3)&&!Compare.ifEqual(y2,y3))||
				(Compare.ifEqual(z2,z1)&&Compare.ifEqual(z4,z3)&&!Compare.ifEqual(z2,z3))){
//			parallel
			Intersection=checkOverLap(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4);
			return Intersection;
		}else if((Compare.ifEqual(x1,x2)&&Compare.ifEqual(x2,x3)&&Compare.ifEqual(x3,x4))||
				(Compare.ifEqual(y1,y2)&&Compare.ifEqual(y2,y3)&&Compare.ifEqual(y3,y4))||
				(Compare.ifEqual(z1,z2)&&Compare.ifEqual(z2,z3)&&Compare.ifEqual(z3,z4))){
//			on a plane(x/y/z)
			if(Compare.ifEqual(x1,x2)&&Compare.ifEqual(x2,x3)&&Compare.ifEqual(x3,x4)){
//				on 'x' plane
				if(Compare.ifEqual(y1,y2)&&Compare.ifEqual(y4,y3)){
//					don't intersects
					Intersection=checkOverLap(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4);
					return Intersection;
				}else if(Compare.ifEqual((z2-z1)/(y2-y1),(z4-z3)/(y4-y3))){
//					don't intersects
					Intersection=checkOverLap(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4);
					return Intersection;
				}else{
					Intersection=checkIntersectionPoint(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,"X");
				}
			}else if(Compare.ifEqual(y1,y2)&&Compare.ifEqual(y2,y3)&&Compare.ifEqual(y3,y4)){
//				on 'y' plane
				if(Compare.ifEqual(z1,z2)&&Compare.ifEqual(z4,z3)){
//					don't intersects
					Intersection=checkOverLap(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4);
					return Intersection;
				}else if(Compare.ifEqual((x2-x1)/(z2-z1),(x4-x3)/(z4-z3))){
//					don't intersects
					Intersection=checkOverLap(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4);
					return Intersection;
				}else{
					Intersection=checkIntersectionPoint(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,"Y");
				}
			}else if(Compare.ifEqual(z1,z2)&&Compare.ifEqual(z2,z3)&&Compare.ifEqual(z3,z4)){
//				on 'z' plane
				if(Compare.ifEqual(x1,x2)&&Compare.ifEqual(x4,x3)){
//					don't intersects
					Intersection=checkOverLap(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4);
					return Intersection;
				}else if(Compare.ifEqual((y2-y1)/(x2-x1),(y4-y3)/(x4-x3))){
//					don't intersects
					Intersection=checkOverLap(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4);
					return Intersection;
				}else{
					Intersection=checkIntersectionPoint(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,"Z");
				}
			}
		}else{
				Intersection=checkIntersectionPoint(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,"");
			}
		return Intersection;
	}
	/**
	 * Check if two line intersects each other
	 * @param x1 "X" of 1st vertex of line one
	 * @param y1 "Y" of 1st vertex of line one
	 * @param z1 "Z" of 1st vertex of line one
	 * @param x2 "X" of 2nd vertex of line one
	 * @param y2 "Y" of 2nd vertex of line one
	 * @param z2 "Z" of 2nd vertex of line one
	 * @param x3 "X" of 1st vertex of line two
	 * @param y3 "Y" of 1st vertex of line two
	 * @param z3 "Z" of 1st vertex of line two
	 * @param x4 "X" of 2nd vertex of line two
	 * @param y4 "Y" of 2nd vertex of line two
	 * @param z4 "Z" of 2nd vertex of line two
	 * @param plane X or Y or Z or none
	 * @return true if intersects
	 */
	private static boolean checkIntersectionPoint(double x1,double y1,double z1,double x2,double y2,double z2,double x3,double y3,double z3,double x4,double y4,double z4,String plane){
		boolean Intersection=false;
		double ta,tb;
		if(plane=="X"){
			double xm = x1;
			double ym = ((y1*z2-z1*y2)*(y3-y4)-(y1-y2)*(y3*z4-z3*y4))/((y1-y2)*(z3-z4)-(z1-z2)*(y3-y4));
			double zm = ((y1*z2-z1*y2)*(z3-z4)-(z1-z2)*(y3*z4-z3*y4))/((y1-y2)*(z3-z4)-(z1-z2)*(y3-y4));
			Intersection = checkIfPointInLine(xm,ym,zm,x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4);
		
		}else if(plane=="Y"){
			double xm = ((z1*x2-x1*z2)*(x3-x4)-(x1-x2)*(z3*x4-x3*z4))/((z1-z2)*(x3-x4)-(x1-x2)*(z3-z4));
			double ym = y1;
			double zm = ((z1*x2-x1*z2)*(z3-z4)-(z1-z2)*(z3*x4-x3*z4))/((z1-z2)*(x3-x4)-(x1-x2)*(z3-z4));
			Intersection = checkIfPointInLine(xm,ym,zm,x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4);
		}else if(plane=="Z"){
			double xm = ((x1*y2-y1*x2)*(x3-x4)-(x1-x2)*(x3*y4-y3*x4))/((x1-x2)*(y3-y4)-(y1-y2)*(x3-x4));
			double ym = ((x1*y2-y1*x2)*(y3-y4)-(y1-y2)*(x3*y4-y3*x4))/((x1-x2)*(y3-y4)-(y1-y2)*(x3-x4));
			double zm = z1;
			Intersection = checkIfPointInLine(xm,ym,zm,x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4);
		}else{
			tb = (((y1-y3)*(x2-x1)+(y2-y1)*(x3-x1))/((x2-x1)*(y4-y3)-(y2-y1)*(x4-x3)));
			ta = ((x3+(x4-x3)*tb-x1)/(x2-x1));
			
			if(Compare.ifEqual((z1+(z2-z1)*ta),(z3+(z4-z3)*tb))){
				if(Double.isInfinite(ta) || Double.isInfinite(tb)){
	//				two lines are parallel or skew
					return false;
				}else{
					double xm = x1+(x2-x1)*ta;
					double ym = y1+(y2-y1)*ta;
					double zm = z1+(z2-z1)*ta;
					Intersection = checkIfPointInLine(xm,ym,zm,x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4);
				}
				
			}
		}
			
		
		return Intersection;
	}
	/**
	 * @param x "X" of intersection point
	 * @param y "Y" of intersection point
	 * @param z "Z" of intersection point
	 * @param x1 "X" of 1st vertex of line one
	 * @param y1 "Y" of 1st vertex of line one
	 * @param z1 "Z" of 1st vertex of line one
	 * @param x2 "X" of 2nd vertex of line one
	 * @param y2 "Y" of 2nd vertex of line one
	 * @param z2 "Z" of 2nd vertex of line one
	 * @param x3 "X" of 1st vertex of line two
	 * @param y3 "Y" of 1st vertex of line two
	 * @param z3 "Z" of 1st vertex of line two
	 * @param x4 "X" of 2nd vertex of line two
	 * @param y4 "Y" of 2nd vertex of line two
	 * @param z4 "Z" of 2nd vertex of line two
	 * @return true if point lies in the lines
	 */
	private static boolean checkIfPointInLine(double x,double y,double z,double x1,double y1,double z1,double x2,double y2,double z2,double x3,double y3,double z3,double x4,double y4,double z4){
		boolean Intersection=true;
		double la=getLength(x1, y1, z1, x2, y2, z2);
		double lb=getLength(x3, y3, z3, x4, y4, z4);
		double l1a=getLength(x, y, z, x1, y1, z1);
		double l2a=getLength(x, y, z, x2, y2, z2);
		double l1b=getLength(x, y, z, x3, y3, z3);
		double l2b=getLength(x, y, z, x4, y4, z4);
		if((Compare.ifEqual(x,x1)&&Compare.ifEqual(y,y1)&&Compare.ifEqual(z,z1)&&Compare.ifEqual(x,x3)&&Compare.ifEqual(y,y3)&&Compare.ifEqual(z,z3))||
				(Compare.ifEqual(x,x1)&&Compare.ifEqual(y,y1)&&Compare.ifEqual(z,z1)&&Compare.ifEqual(x,x4)&&Compare.ifEqual(y,y4)&&Compare.ifEqual(z,z4))||
				(Compare.ifEqual(x,x2)&&Compare.ifEqual(y,y2)&&Compare.ifEqual(z,z2)&&Compare.ifEqual(x,x3)&&Compare.ifEqual(y,y3)&&Compare.ifEqual(z,z3))||
				(Compare.ifEqual(x,x2)&&Compare.ifEqual(y,y2)&&Compare.ifEqual(z,z2)&&Compare.ifEqual(x,x4)&&Compare.ifEqual(y,y4)&&Compare.ifEqual(z,z4))){
			return false;
		}
		if(la<l1a||la<l2a||lb<l2b||lb<l1b){
			Intersection=false;
		}else{
			Intersection=true;
			if(intersection.size()<1)intersection.add(new double[]{x,y,z});
		}
		return Intersection;
	}
	/**
	 * Calculate length of line
	 * @param ax "X" of 1st vertex of line
	 * @param ay "Y" of 1st vertex of line
	 * @param az "Z" of 1st vertex of line
	 * @param bx "X" of 2nd vertex of line
	 * @param by "Y" of 2nd vertex of line
	 * @param bz "Z" of 2nd vertex of line
	 * @return length of line
	 */
	private static double getLength(double ax,double ay,double az,double bx,double by,double bz){
		double Length=0.0;
		double x = (ax*1E10-bx*1E10)/1E10;
		double y = (ay*1E10-by*1E10)/1E10;
		double z = (az*1E10-bz*1E10)/1E10;
		Length=Math.sqrt(Math.pow(x,2)+Math.pow(y,2)+Math.pow(z,2));
		return Length;
	}
	/**
	 * Checks if there is an overlap between lines
	 * @param x1 "X" of 1st vertex of line one
	 * @param y1 "Y" of 1st vertex of line one
	 * @param z1 "Z" of 1st vertex of line one
	 * @param x2 "X" of 2nd vertex of line one
	 * @param y2 "Y" of 2nd vertex of line one
	 * @param z2 "Z" of 2nd vertex of line one
	 * @param x3 "X" of 1st vertex of line two
	 * @param y3 "Y" of 1st vertex of line two
	 * @param z3 "Z" of 1st vertex of line two
	 * @param x4 "X" of 2nd vertex of line two
	 * @param y4 "Y" of 2nd vertex of line two
	 * @param z4 "Z" of 2nd vertex of line two
	 * @return true if overlaps
	 */
	private static boolean checkOverLap(double x1,double y1,double z1,double x2,double y2,double z2,double x3,double y3,double z3,double x4,double y4,double z4){
		boolean Intersection=false;
		double l12=getLength(x1, y1, z1, x2, y2, z2);
		double l34=getLength(x3, y3, z3, x4, y4, z4);
		double l13=getLength(x3, y3, z3, x1, y1, z1);
		double l14=getLength(x4, y4, z4, x1, y1, z1);
		double l23=getLength(x2, y2, z2, x3, y3, z3);
		double l24=getLength(x2, y2, z2, x4, y4, z4);
		
		if((Compare.ifEqual(x1,x3)&&Compare.ifEqual(y1,y3)&&Compare.ifEqual(z1,z3)&&Compare.ifEqual(x2,x4)&&Compare.ifEqual(y2,y4)&&Compare.ifEqual(z2,z4))||
				(Compare.ifEqual(x2,x3)&&Compare.ifEqual(y2,y3)&&Compare.ifEqual(z2,z3)&&Compare.ifEqual(x1,x4)&&Compare.ifEqual(y1,y4)&&Compare.ifEqual(z1,z4))){
//		if((l12==l23 && l12==l14)||(l12==l13 && l12==l24)){
			intersection.add(new double[]{x1, y1, z1});
			intersection.add(new double[]{x2, y2, z2});
		}else{
			if(Compare.ifEqual(l12,l13+l23) && l13>0 && l23>0){
				overlap = new double[]{x3, y3, z3};
				intersection.add(overlap);
			}
			if(Compare.ifEqual(l12,l14+l24) && l14>0 && l24>0){
				overlap = new double[]{x4, y4, z4};
				intersection.add(overlap);
			}
			if(Compare.ifEqual(l34,l23+l24) && l23>0 && l24>0){
				overlap = new double[]{x2, y2, z2};
				intersection.add(overlap);
			}
			if(Compare.ifEqual(l34,l13+l14) && l14>0 && l13>0){
				overlap = new double[]{x1, y1, z1};
				intersection.add(overlap);
			}
		}
		if(intersection.size()<2)intersection =  new ArrayList<double[]>();
		
		return Intersection;
	}
	/**
	 * Getter of the property <tt>intersection</tt>
	 * @return the intersection
	 * @uml.property name = "intersection"
	 */
	public static List<double[]> getIntersection() {
		return intersection;
	}
	/**
	 * Setter of the property <tt>intersection</tt>
	 * @param intersection the intersection to set
	 * @uml.property name = "intersection"
	 */
	public void setIntersection(List<double[]> intersection) {
		this.intersection = intersection;
	}
	
}
