/** -------------------------------------------------- 
* Hochschule f�r Technik Stuttgart 
* Fachbereich Vermessung , Informatik und Mathematik 
* Schellingstr . 24 
* D - 70174 Stuttgart 
* 
* Projekt CityDoktor 
* 
* Copyright (c) 2011 HFT Stuttgart. All rights reserved. 
* HFT Stuttgart and its licensors retain all intellectual property and 
* proprietary rights in and to this software and related documentation. 
* Any use, reproduction, disclosure, or distribution of this software 
* and related documentation without an express license agreement from 
* HFT Stuttgart is strictly prohibited. 
* 
* Please refer to the applicable HFT Stuttgart end user license agreement (EULA) 
* associated with this source code for terms and conditions that govern 
* your use of this HFT Stuttgart software. 
* 
* @author 
* @version 
* 
*/


package de.hft.stuttgart.linearalgebra;

import java.util.Arrays;

import Jama.Matrix;
import de.hft.stuttgart.linearalgebra.CheckLineLineIntersection;


/**
 * This method check intersection of a line and a triangle.
 * @author alam
 *
 */
public class CheckLinePlaneIntersection {

	private static CheckLineLineIntersection lineCheck = new CheckLineLineIntersection();
	public static double[] intersectionPoint;
	/**
	 * Constructor
	 */
	public CheckLinePlaneIntersection(){
		
	}
	/**
	 * Check if a line and triangle intersects
	 * @param line_a 1st vertex of line
	 * @param line_b 2nd vertex of line
	 * @param triangle_A 1st vertex of triangle
	 * @param triangle_B 2nd vertex of triangle
	 * @param triangle_C 3rd vertex of triangle
	 * @return true if intersects
	 */
	public static boolean getIntersectionPoint(double[] line_a, double[] line_b, double[] triangle_A, double[] triangle_B, double[] triangle_C) 
	{
		boolean intersection = false;
		intersectionPoint = null;
		double triangleAx = triangle_A[0];
		double triangleAy = triangle_A[1];
		double triangleAz = triangle_A[2];
		
		double triangleBx = triangle_B[0];
		double triangleBy = triangle_B[1];
		double triangleBz = triangle_B[2];
		
		double triangleCx = triangle_C[0];
		double triangleCy = triangle_C[1];
		double triangleCz = triangle_C[2];
		
		double line_ax = line_a[0];
		double line_ay = line_a[1];
		double line_az = line_a[2];
		
		double line_bx = line_b[0];
		double line_by = line_b[1];
		double line_bz = line_b[2];
		
		
		double[][] array1 = 	{{line_ax-triangleAx},
								{line_ay-triangleAy},
								{line_az-triangleAz}};
		Matrix m1 = new Matrix(array1);
	    double[][] array2 = 	{{line_ax-line_bx,triangleBx-triangleAx,triangleCx-triangleAx},
	    						{line_ay-line_by,triangleBy-triangleAy,triangleCy-triangleAy},
	    						{line_az-line_bz,triangleBz-triangleAz,triangleCz-triangleAz}};
	    Matrix m2 = new Matrix(array2);
	    if(m2.det()==0){
	    	boolean x = false;
	    	if(x==false){
	    		x=lineCheck.checkIntersection(line_a, line_b, triangle_A, triangle_B);
	    	}else if(x==false){
	    		x=lineCheck.checkIntersection(line_a, line_b, triangle_C, triangle_B);
	    	} else if(x==false){
	    		x=lineCheck.checkIntersection(line_a, line_b, triangle_A, triangle_C);
	    	}
	    	intersection=x;
	//    	System.out.println("||");
	    }else{
			Matrix mt = m2.inverse().times(m1);
	
			double t = mt.get(0, 0);
			double u = mt.get(1, 0);
			double v = mt.get(2, 0);
	//		initialize intersection points coordinates
			double X = 0.0;
			double Y = 0.0;
			double Z = 0.0;
			
			if( t>=0 && t<=1 && u>=0 && u<=1 && v>=0 && v<=1 && (u+v)<=1)
			{
				X = line_ax+(line_bx-line_ax)*t;
				Y = line_ay+(line_by-line_ay)*t;
				Z = line_az+(line_bz-line_az)*t;
				
	//			System.out.println("Intersection Point: "+X+", "+Y+", "+Z);
				if(!Compare.ifEqual(X , line_ax) || !Compare.ifEqual(Y , line_ay) || !Compare.ifEqual(Z , line_az)){
					if(((X-line_ax)>0.000001||(line_ax-X)>0.000001)||
							((Y-line_ay)>0.000001||(line_ay-Y)>0.000001)||
							((Z-line_az)>0.000001||(line_az-Z)>0.000001)){
						intersection = true;
//						System.out.print("x");
//						System.out.println("Intersection Point: "+X+", "+Y+", "+Z);
						intersectionPoint=new double[]{X,Y,Z};
					}
				}
				
			}else{
//				System.out.print(".");
			}
	    }	
	    return intersection;
	}
}
