/** -------------------------------------------------- 
* Hochschule f�r Technik Stuttgart 
* Fachbereich Vermessung , Informatik und Mathematik 
* Schellingstr . 24 
* D - 70174 Stuttgart 
* 
* Projekt CityDoktor 
* 
* Copyright (c) 2011 HFT Stuttgart. All rights reserved. 
* HFT Stuttgart and its licensors retain all intellectual property and 
* proprietary rights in and to this software and related documentation. 
* Any use, reproduction, disclosure, or distribution of this software 
* and related documentation without an express license agreement from 
* HFT Stuttgart is strictly prohibited. 
* 
* Please refer to the applicable HFT Stuttgart end user license agreement (EULA) 
* associated with this source code for terms and conditions that govern 
* your use of this HFT Stuttgart software. 
* 
* @author alam
* @version 
* 
*/ 
package de.hft.stuttgart.linearalgebra;

/**
 * @author alam
 *
 */
public class Compare {
	/**
	 * if two double value have a difference less than delta then they are considered as equal
	 * @param a first double value
	 * @param b second double value
	 * @return true if equal, false if not.
	 */
	public static boolean ifEqual(double a, double b, double delta){
		if(Math.abs(a-b)>delta){
			return false;
		}else{
			return true;
		}
	}
	/**
	 * if two float value have a difference less than delta then they are considered as equal
	 * @param a first float value
	 * @param b second float value
	 * @return true if equal, false if not.
	 */
	public static boolean ifEqual(float a, float b, double delta){
		if(Math.abs(a-b)>delta){
			return false;
		}else{
			return true;
		}
	}
	/**
	 * if two double value have a difference less than 1E-12 then they are considered as equal
	 * @param a first double value
	 * @param b second double value
	 * @return true if equal, false if not.
	 */
	public static boolean ifEqual(double a, double b){
		
		return ifEqual(a, b,1E-12);
		
	}
	/**
	 * if two float value have a difference less than 1E-12 then they are considered as equal
	 * @param a first float value
	 * @param b second float value
	 * @return true if equal, false if not.
	 */
	public static boolean ifEqual(float a, float b){
		return ifEqual(a, b,1E-12);
	}
	/**
	 * Calculate average of two coordinate.
	 * @param a first point
	 * @param b second point
	 * @return average of two points.
	 */
	public static double[] getAverage(double[] a, double[] b){
		if(a==null)return b;
		if(b==null)return a;
		if(a.length!=b.length)return null;
		double[] average = new double[a.length];
		for(int i=0;i<a.length;i++){
		average[i]=(a[i]+b[i])/2.0;
		}
		return average;
	}
	/**
	 * if two double value have a difference less than delta then they are considered as equal
	 * @param a first double value
	 * @param b second double value
	 * @return true if equal, false if not.
	 */
	public static boolean ifEqual(double a[], double b[], double delta){
		if(a==null&&b==null)return true;
		if(a==null||b==null)return false;
		if(a.length!=b.length)return false;
		for(int i=0;i<a.length;i++){
			if(!ifEqual(a[i], b[i], delta))return false;
		}
		return true;
	}
	/**
	 * if any corresponding element of the two float array have a difference less than delta then they are considered as equal
	 * @param a first float array
	 * @param b second float array
	 * @return true if equal, false if not.
	 */
	public static boolean ifEqual(float a[], float b[], double delta){
		if(a==null&&b==null)return true;
		if(a==null||b==null)return false;
		if(a.length!=b.length)return false;
		for(int i=0;i<a.length;i++){
			if(!ifEqual(a[i], b[i], delta))return false;
		}
		return true;
	}
	/**
	 * if two double value have a difference less than 1E-12 then they are considered as equal
	 * @param a first double value
	 * @param b second double value
	 * @return true if equal, false if not.
	 */
	public static boolean ifEqual(double a[], double b[]){
		
		return ifEqual(a, b,1E-12);
		
	}
	/**
	 * if two float value have a difference less than 1E-12 then they are considered as equal
	 * @param a first float value
	 * @param b second float value
	 * @return true if equal, false if not.
	 */
	public static boolean ifEqual(float a[], float b[]){
		return ifEqual(a, b,1E-12);
	}
}
