/** -------------------------------------------------- 
* Hochschule f�r Technik Stuttgart 
* Fachbereich Vermessung , Informatik und Mathematik 
* Schellingstr . 24 
* D - 70174 Stuttgart 
* 
* Projekt CityDoktor 
* 
* Copyright (c) 2011 HFT Stuttgart. All rights reserved. 
* HFT Stuttgart and its licensors retain all intellectual property and 
* proprietary rights in and to this software and related documentation. 
* Any use, reproduction, disclosure, or distribution of this software 
* and related documentation without an express license agreement from 
* HFT Stuttgart is strictly prohibited. 
* 
* Please refer to the applicable HFT Stuttgart end user license agreement (EULA) 
* associated with this source code for terms and conditions that govern 
* your use of this HFT Stuttgart software. 
* 
* @author 
* @version 
* 
*/


package de.hft.stuttgart.linearalgebra;

import java.util.ArrayList;
import java.util.List;


import javax.media.opengl.glu.GLU;
import javax.media.opengl.glu.GLUtessellator;
import javax.media.opengl.glu.GLUtessellatorCallback;



/**
 * @author alam
 *
 */
public class Tessellator implements GLUtessellatorCallback {
	

	private List<Integer> tessVertices = new ArrayList<Integer>();
	private List<double[]> tessVertices1 = new ArrayList<double[]>();
	private GLUtessellator tess = null;
	private GLU glu = null;
	private int vertexCount = 0;

	public Tessellator() {
		
		glu = new GLU();
		tess = GLU.gluNewTess();
		
		GLU.gluTessCallback(tess, GLU.GLU_TESS_BEGIN, this);
		GLU.gluTessCallback(tess, GLU.GLU_TESS_END, this);
		GLU.gluTessCallback(tess, GLU.GLU_TESS_EDGE_FLAG, this); 
		GLU.gluTessCallback(tess, GLU.GLU_TESS_VERTEX_DATA, this);
		GLU.gluTessCallback(tess, GLU.GLU_TESS_ERROR_DATA, this);
		GLU.gluTessCallback(tess, GLU.GLU_TESS_COMBINE_DATA, this);
	}

	public List<Integer> tess(double example[][], double[] normal){
		
		if(example==null) return null;
		double[] coords = new double[3];
		double[] vertexInfo = null; 

		//start the first polygon
		GLU.gluTessBeginPolygon(tess, 0);
		GLU.gluTessBeginContour(tess);
		GLU.gluTessNormal(tess, normal[0], normal[1], normal[2]);
		
		for(int v = 0; v < example.length; v++) {
			
			coords[0]	= example[v][0];
			coords[1]	= example[v][1];
			coords[2]	= example[v][2];
			vertexInfo = new double [1];
			vertexInfo[0] 		= example[v][3];
			GLU.gluTessVertex(tess, coords, 0, vertexInfo);
			
		}
		GLU.gluTessEndContour(tess);
		GLU.gluTessEndPolygon(tess);
		
//		System.out.print("CoordIndex");
//		for(int t = 0; t < tessVertices.size(); t++) {
//			System.out.print(" " + tessVertices.get(t));
//		}

		return tessVertices;
	}
	public List<double[]> tess(List <double[]> polygon){
		
		if(polygon==null) return null;
		double[] coords = new double[3];
		double[] vertexInfo = null; 
		List<double[]> newPointList = new ArrayList<double[]>();
		double 	xx, yy, zz,
		ax, ay, az,
		bx, by, bz,
		ux, uy, uz,
		cx, cy, cz,
		vx, vy, vz,
		nx, ny, nz;

		int pointID = 0;
		int a,b,c;
		xx = polygon.get(0)[0];
		yy = polygon.get(0)[1];
		zz = polygon.get(0)[2];
		
		//ignore 'z' and take the highest value of 'y'
		for (int i=1;i<polygon.size()-1;i++){
			if(xx>polygon.get(i)[0]){
//				do nothing
			}else if(Compare.ifEqual(xx,polygon.get(i)[0])){
				if(yy>polygon.get(i)[1]){
//					do nothing
				}else if(Compare.ifEqual(yy,polygon.get(i)[1])){
					if(zz>polygon.get(i)[2]){
//						do nothing
					}else if(Compare.ifEqual(zz,polygon.get(i)[2])){
//						do nothing
					}else if(zz<polygon.get(i)[2]){
						pointID=i;
						xx = polygon.get(i)[0];
						yy = polygon.get(i)[1];
						zz = polygon.get(i)[2];
					}else{
						System.out.println("error");
					}
				}else if(yy<polygon.get(i)[1]){
					pointID=i;
					xx = polygon.get(i)[0];
					yy = polygon.get(i)[1];
					zz = polygon.get(i)[2];
				}else{
					System.out.println("error");
				}
			}else if(xx<polygon.get(i)[0]){
				pointID=i;
				xx = polygon.get(i)[0];
				yy = polygon.get(i)[1];
				zz = polygon.get(i)[2];
			}else{
				System.out.println("error");
			}
		}
//		System.out.println(xx+" "+yy+" "+zz);
		a=pointID-1;
		b=pointID;
		c=pointID+1;
		if(pointID==0){
			a=polygon.size()-2;
		}
		ax = polygon.get(a)[0];
		ay = polygon.get(a)[1];
		az = polygon.get(a)[2];
		bx = polygon.get(b)[0];
		by = polygon.get(b)[1];
		bz = polygon.get(b)[2];
		cx = polygon.get(c)[0];
		cy = polygon.get(c)[1];
		cz = polygon.get(c)[2];
		// Erster Richtungsvektor u = AB
		ux = bx - ax;
		uy = by - ay;
		uz = bz - az;
		// Zweiter Richtungsvektor v = AC
		vx = cx - ax;
		vy = cy - ay;
		vz = cz - az;
		// Normalenvektor n aus Kreuzprodukt von u und v
		nx = (uy * vz) - (uz * vy);
		ny = (uz * vx) - (ux * vz);
		nz = (ux * vy) - (uy * vx);
		//start the first polygon
		GLU.gluTessBeginPolygon(tess, 0);
		GLU.gluTessBeginContour(tess);
		GLU.gluTessNormal(tess, nx, ny, nz);
		for(int v = 0; v < polygon.size(); v++) {
			
			coords[0]	= polygon.get(v)[0];
			coords[1]	= polygon.get(v)[1];
			coords[2]	= polygon.get(v)[2];
			vertexInfo = new double [1];
			vertexInfo[0] 		= v;
			GLU.gluTessVertex(tess, coords, 0, vertexInfo);
			
		}
		GLU.gluTessEndContour(tess);
		GLU.gluTessEndPolygon(tess);
		
//		System.out.print("CoordIndex");
		for(int t = 0; t < tessVertices.size(); t++) {
//			System.out.print(" " + tessVertices.get(t));
			if(tessVertices.get(t)!=(-1)){
				
				newPointList.add(polygon.get(tessVertices.get(t)));
			}
		}

		return newPointList;
	}

	/**
	 * Triangulates a Polygon using OpenGL
	 * @param polygon List of LinearRings where, first List of double[] is exterior ring and the rest are interior rings.
	 * and double[] is vertex as [x,y,z]
	 * @return Triangulated Polygon as List of double[] where each {double[3*n], double[3*n+1],double[3*n+2]} is a triangle
	 */
	public List<double[]> triangulatePolygon(List<List<double[]>> polygon){
		
		if(polygon==null) return null;
		if(polygon.get(0)==null) return null;
		GLU.gluTessBeginPolygon(tess, MathUtils.getNormalOfSurface(polygon.get(0)));
		for (int j = 0; j < polygon.size(); j++) {
			GLU.gluTessBeginContour(tess);
			for (int v = 0; v < polygon.get(j).size(); v++) {
				GLU.gluTessVertex(tess, polygon.get(j).get(v), 0, polygon.get(j).get(v));
			}
			GLU.gluTessEndContour(tess);
		}
		GLU.gluTessEndPolygon(tess);
		
		return tessVertices1;
	}

	/* (non-Javadoc)
	 * @see javax.media.opengl.glu.GLUtessellatorCallback#begin(int)
	 */
	@Override
	public void begin(int mode) {
		

	}

	/* (non-Javadoc)
	 * @see javax.media.opengl.glu.GLUtessellatorCallback#beginData(int, java.lang.Object)
	 */
	@Override
	public void beginData(int arg0, Object arg1) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.media.opengl.glu.GLUtessellatorCallback#combine(double[], java.lang.Object[], float[], java.lang.Object[])
	 */
	@Override
	public void combine(double[] coords, Object[] neighbours, float[] weight,
			Object[] outData) {
		
	}

	/* (non-Javadoc)
	 * @see javax.media.opengl.glu.GLUtessellatorCallback#combineData(double[], java.lang.Object[], float[], java.lang.Object[], java.lang.Object)
	 */
	@Override
	public void combineData(double[] coords, Object[] neighbours, float[] weight,
			Object[] outData, Object data) {

	}

	/* (non-Javadoc)
	 * @see javax.media.opengl.glu.GLUtessellatorCallback#edgeFlag(boolean)
	 */
	@Override
	public void edgeFlag(boolean arg0) {
		

	}

	/* (non-Javadoc)
	 * @see javax.media.opengl.glu.GLUtessellatorCallback#edgeFlagData(boolean, java.lang.Object)
	 */
	@Override
	public void edgeFlagData(boolean arg0, Object arg1) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.media.opengl.glu.GLUtessellatorCallback#end()
	 */
	@Override
	public void end() {
		
	}

	/* (non-Javadoc)
	 * @see javax.media.opengl.glu.GLUtessellatorCallback#endData(java.lang.Object)
	 */
	@Override
	public void endData(Object arg0) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see javax.media.opengl.glu.GLUtessellatorCallback#error(int)
	 */
	@Override
	public void error(int code) {
		
	}

	/* (non-Javadoc)
	 * @see javax.media.opengl.glu.GLUtessellatorCallback#errorData(int, java.lang.Object)
	 */
	@Override
	public void errorData(int code, Object arg1) {
		
		String estring;
	    estring = glu.gluErrorString(code);
	    System.err.println("Tessellation Error: " + estring);
	}

	/* (non-Javadoc)
	 * @see javax.media.opengl.glu.GLUtessellatorCallback#vertex(java.lang.Object)
	 */
	@Override
	public void vertex(Object obj) {
		
		
	}

	/* (non-Javadoc)
	 * @see javax.media.opengl.glu.GLUtessellatorCallback#vertexData(java.lang.Object, java.lang.Object)
	 */
	@Override
	public void vertexData(Object obj, Object data) {
		
		double[] vertexInfo = (double[]) obj;
		int a = (int)vertexInfo[0];
		tessVertices.add(a);
		vertexCount++;
		tessVertices1.add(vertexInfo);
		if(vertexCount == 3) {
			tessVertices.add(-1);
			
			vertexCount = 0;
		}
		
	}
}
