/**
 */
package de.hftstuttgart.energycomponents.impl;

import de.hftstuttgart.energycomponents.Characteristic;
import de.hftstuttgart.energycomponents.EnCompFactory;
import de.hftstuttgart.energycomponents.EnCompPackage;
import de.hftstuttgart.energycomponents.FuelTypes;
import de.hftstuttgart.energycomponents.HeatPump;
import de.hftstuttgart.energycomponents.HeatSources;
import de.hftstuttgart.energycomponents.ThermalEnergyDevice;
import de.hftstuttgart.units.NullableQuantity;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Heat Pump</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HeatPumpImpl#getInstalledThermalPower <em>Installed Thermal Power</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HeatPumpImpl#getModulationRange <em>Modulation Range</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HeatPumpImpl#getFuel <em>Fuel</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HeatPumpImpl#getHeatSource <em>Heat Source</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HeatPumpImpl#getCoefficientOfPerformance <em>Coefficient Of Performance</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HeatPumpImpl#getPowerInput <em>Power Input</em>}</li>
 *   <li>{@link de.hftstuttgart.energycomponents.impl.HeatPumpImpl#getHeatOutput <em>Heat Output</em>}</li>
 * </ul>
 *
 * @generated
 */
public class HeatPumpImpl extends EnergyComponentImpl implements HeatPump {
	/**
	 * The default value of the '{@link #getInstalledThermalPower() <em>Installed Thermal Power</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInstalledThermalPower()
	 * @generated
	 * @ordered
	 */
	protected static final NullableQuantity INSTALLED_THERMAL_POWER_EDEFAULT = (NullableQuantity) EnCompFactory.eINSTANCE
			.createFromString(EnCompPackage.eINSTANCE.getQuantityDouble(), "kW");

	/**
	 * The cached value of the '{@link #getInstalledThermalPower() <em>Installed Thermal Power</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInstalledThermalPower()
	 * @generated
	 * @ordered
	 */
	protected NullableQuantity installedThermalPower = INSTALLED_THERMAL_POWER_EDEFAULT;

	/**
	 * The default value of the '{@link #getModulationRange() <em>Modulation Range</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModulationRange()
	 * @generated
	 * @ordered
	 */
	protected static final double MODULATION_RANGE_EDEFAULT = 0.5;

	/**
	 * The cached value of the '{@link #getModulationRange() <em>Modulation Range</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getModulationRange()
	 * @generated
	 * @ordered
	 */
	protected double modulationRange = MODULATION_RANGE_EDEFAULT;

	/**
	 * The default value of the '{@link #getFuel() <em>Fuel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFuel()
	 * @generated
	 * @ordered
	 */
	protected static final FuelTypes FUEL_EDEFAULT = FuelTypes.NATURAL_GAS;

	/**
	 * The cached value of the '{@link #getFuel() <em>Fuel</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFuel()
	 * @generated
	 * @ordered
	 */
	protected FuelTypes fuel = FUEL_EDEFAULT;

	/**
	 * The default value of the '{@link #getHeatSource() <em>Heat Source</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeatSource()
	 * @generated
	 * @ordered
	 */
	protected static final HeatSources HEAT_SOURCE_EDEFAULT = HeatSources.AIR;

	/**
	 * The cached value of the '{@link #getHeatSource() <em>Heat Source</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeatSource()
	 * @generated
	 * @ordered
	 */
	protected HeatSources heatSource = HEAT_SOURCE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getCoefficientOfPerformance() <em>Coefficient Of Performance</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCoefficientOfPerformance()
	 * @generated
	 * @ordered
	 */
	protected Characteristic coefficientOfPerformance;

	/**
	 * The cached value of the '{@link #getPowerInput() <em>Power Input</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPowerInput()
	 * @generated
	 * @ordered
	 */
	protected Characteristic powerInput;

	/**
	 * The cached value of the '{@link #getHeatOutput() <em>Heat Output</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getHeatOutput()
	 * @generated
	 * @ordered
	 */
	protected Characteristic heatOutput;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HeatPumpImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EnCompPackage.Literals.HEAT_PUMP;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public HeatSources getHeatSource() {
		return heatSource;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setHeatSource(HeatSources newHeatSource) {
		HeatSources oldHeatSource = heatSource;
		heatSource = newHeatSource == null ? HEAT_SOURCE_EDEFAULT : newHeatSource;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.HEAT_PUMP__HEAT_SOURCE, oldHeatSource,
					heatSource));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public double getModulationRange() {
		return modulationRange;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setModulationRange(double newModulationRange) {
		double oldModulationRange = modulationRange;
		modulationRange = newModulationRange;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.HEAT_PUMP__MODULATION_RANGE,
					oldModulationRange, modulationRange));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public FuelTypes getFuel() {
		return fuel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setFuel(FuelTypes newFuel) {
		FuelTypes oldFuel = fuel;
		fuel = newFuel == null ? FUEL_EDEFAULT : newFuel;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.HEAT_PUMP__FUEL, oldFuel, fuel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Characteristic getPowerInput() {
		return powerInput;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPowerInput(Characteristic newPowerInput, NotificationChain msgs) {
		Characteristic oldPowerInput = powerInput;
		powerInput = newPowerInput;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					EnCompPackage.HEAT_PUMP__POWER_INPUT, oldPowerInput, newPowerInput);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setPowerInput(Characteristic newPowerInput) {
		if (newPowerInput != powerInput) {
			NotificationChain msgs = null;
			if (powerInput != null)
				msgs = ((InternalEObject) powerInput).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - EnCompPackage.HEAT_PUMP__POWER_INPUT, null, msgs);
			if (newPowerInput != null)
				msgs = ((InternalEObject) newPowerInput).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - EnCompPackage.HEAT_PUMP__POWER_INPUT, null, msgs);
			msgs = basicSetPowerInput(newPowerInput, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.HEAT_PUMP__POWER_INPUT, newPowerInput,
					newPowerInput));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Characteristic getHeatOutput() {
		return heatOutput;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetHeatOutput(Characteristic newHeatOutput, NotificationChain msgs) {
		Characteristic oldHeatOutput = heatOutput;
		heatOutput = newHeatOutput;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					EnCompPackage.HEAT_PUMP__HEAT_OUTPUT, oldHeatOutput, newHeatOutput);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setHeatOutput(Characteristic newHeatOutput) {
		if (newHeatOutput != heatOutput) {
			NotificationChain msgs = null;
			if (heatOutput != null)
				msgs = ((InternalEObject) heatOutput).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - EnCompPackage.HEAT_PUMP__HEAT_OUTPUT, null, msgs);
			if (newHeatOutput != null)
				msgs = ((InternalEObject) newHeatOutput).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - EnCompPackage.HEAT_PUMP__HEAT_OUTPUT, null, msgs);
			msgs = basicSetHeatOutput(newHeatOutput, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.HEAT_PUMP__HEAT_OUTPUT, newHeatOutput,
					newHeatOutput));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NullableQuantity getInstalledThermalPower() {
		return installedThermalPower;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setInstalledThermalPower(NullableQuantity newInstalledThermalPower) {
		NullableQuantity oldInstalledThermalPower = installedThermalPower;
		installedThermalPower = newInstalledThermalPower;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.HEAT_PUMP__INSTALLED_THERMAL_POWER,
					oldInstalledThermalPower, installedThermalPower));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Characteristic getCoefficientOfPerformance() {
		return coefficientOfPerformance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCoefficientOfPerformance(Characteristic newCoefficientOfPerformance,
			NotificationChain msgs) {
		Characteristic oldCoefficientOfPerformance = coefficientOfPerformance;
		coefficientOfPerformance = newCoefficientOfPerformance;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET,
					EnCompPackage.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE, oldCoefficientOfPerformance,
					newCoefficientOfPerformance);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setCoefficientOfPerformance(Characteristic newCoefficientOfPerformance) {
		if (newCoefficientOfPerformance != coefficientOfPerformance) {
			NotificationChain msgs = null;
			if (coefficientOfPerformance != null)
				msgs = ((InternalEObject) coefficientOfPerformance).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE - EnCompPackage.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE, null, msgs);
			if (newCoefficientOfPerformance != null)
				msgs = ((InternalEObject) newCoefficientOfPerformance).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE - EnCompPackage.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE, null, msgs);
			msgs = basicSetCoefficientOfPerformance(newCoefficientOfPerformance, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EnCompPackage.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE,
					newCoefficientOfPerformance, newCoefficientOfPerformance));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
		case EnCompPackage.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE:
			return basicSetCoefficientOfPerformance(null, msgs);
		case EnCompPackage.HEAT_PUMP__POWER_INPUT:
			return basicSetPowerInput(null, msgs);
		case EnCompPackage.HEAT_PUMP__HEAT_OUTPUT:
			return basicSetHeatOutput(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
		case EnCompPackage.HEAT_PUMP__INSTALLED_THERMAL_POWER:
			return getInstalledThermalPower();
		case EnCompPackage.HEAT_PUMP__MODULATION_RANGE:
			return getModulationRange();
		case EnCompPackage.HEAT_PUMP__FUEL:
			return getFuel();
		case EnCompPackage.HEAT_PUMP__HEAT_SOURCE:
			return getHeatSource();
		case EnCompPackage.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE:
			return getCoefficientOfPerformance();
		case EnCompPackage.HEAT_PUMP__POWER_INPUT:
			return getPowerInput();
		case EnCompPackage.HEAT_PUMP__HEAT_OUTPUT:
			return getHeatOutput();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
		case EnCompPackage.HEAT_PUMP__INSTALLED_THERMAL_POWER:
			setInstalledThermalPower((NullableQuantity) newValue);
			return;
		case EnCompPackage.HEAT_PUMP__MODULATION_RANGE:
			setModulationRange((Double) newValue);
			return;
		case EnCompPackage.HEAT_PUMP__FUEL:
			setFuel((FuelTypes) newValue);
			return;
		case EnCompPackage.HEAT_PUMP__HEAT_SOURCE:
			setHeatSource((HeatSources) newValue);
			return;
		case EnCompPackage.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE:
			setCoefficientOfPerformance((Characteristic) newValue);
			return;
		case EnCompPackage.HEAT_PUMP__POWER_INPUT:
			setPowerInput((Characteristic) newValue);
			return;
		case EnCompPackage.HEAT_PUMP__HEAT_OUTPUT:
			setHeatOutput((Characteristic) newValue);
			return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
		case EnCompPackage.HEAT_PUMP__INSTALLED_THERMAL_POWER:
			setInstalledThermalPower(INSTALLED_THERMAL_POWER_EDEFAULT);
			return;
		case EnCompPackage.HEAT_PUMP__MODULATION_RANGE:
			setModulationRange(MODULATION_RANGE_EDEFAULT);
			return;
		case EnCompPackage.HEAT_PUMP__FUEL:
			setFuel(FUEL_EDEFAULT);
			return;
		case EnCompPackage.HEAT_PUMP__HEAT_SOURCE:
			setHeatSource(HEAT_SOURCE_EDEFAULT);
			return;
		case EnCompPackage.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE:
			setCoefficientOfPerformance((Characteristic) null);
			return;
		case EnCompPackage.HEAT_PUMP__POWER_INPUT:
			setPowerInput((Characteristic) null);
			return;
		case EnCompPackage.HEAT_PUMP__HEAT_OUTPUT:
			setHeatOutput((Characteristic) null);
			return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
		case EnCompPackage.HEAT_PUMP__INSTALLED_THERMAL_POWER:
			return INSTALLED_THERMAL_POWER_EDEFAULT == null ? installedThermalPower != null
					: !INSTALLED_THERMAL_POWER_EDEFAULT.equals(installedThermalPower);
		case EnCompPackage.HEAT_PUMP__MODULATION_RANGE:
			return modulationRange != MODULATION_RANGE_EDEFAULT;
		case EnCompPackage.HEAT_PUMP__FUEL:
			return fuel != FUEL_EDEFAULT;
		case EnCompPackage.HEAT_PUMP__HEAT_SOURCE:
			return heatSource != HEAT_SOURCE_EDEFAULT;
		case EnCompPackage.HEAT_PUMP__COEFFICIENT_OF_PERFORMANCE:
			return coefficientOfPerformance != null;
		case EnCompPackage.HEAT_PUMP__POWER_INPUT:
			return powerInput != null;
		case EnCompPackage.HEAT_PUMP__HEAT_OUTPUT:
			return heatOutput != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass) {
		if (baseClass == ThermalEnergyDevice.class) {
			switch (derivedFeatureID) {
			case EnCompPackage.HEAT_PUMP__INSTALLED_THERMAL_POWER:
				return EnCompPackage.THERMAL_ENERGY_DEVICE__INSTALLED_THERMAL_POWER;
			case EnCompPackage.HEAT_PUMP__MODULATION_RANGE:
				return EnCompPackage.THERMAL_ENERGY_DEVICE__MODULATION_RANGE;
			case EnCompPackage.HEAT_PUMP__FUEL:
				return EnCompPackage.THERMAL_ENERGY_DEVICE__FUEL;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass) {
		if (baseClass == ThermalEnergyDevice.class) {
			switch (baseFeatureID) {
			case EnCompPackage.THERMAL_ENERGY_DEVICE__INSTALLED_THERMAL_POWER:
				return EnCompPackage.HEAT_PUMP__INSTALLED_THERMAL_POWER;
			case EnCompPackage.THERMAL_ENERGY_DEVICE__MODULATION_RANGE:
				return EnCompPackage.HEAT_PUMP__MODULATION_RANGE;
			case EnCompPackage.THERMAL_ENERGY_DEVICE__FUEL:
				return EnCompPackage.HEAT_PUMP__FUEL;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (installedThermalPower: ");
		result.append(installedThermalPower);
		result.append(", modulationRange: ");
		result.append(modulationRange);
		result.append(", fuel: ");
		result.append(fuel);
		result.append(", heatSource: ");
		result.append(heatSource);
		result.append(')');
		return result.toString();
	}

} //HeatPumpImpl
