
package eu.simstadt.ade.energy;

import java.util.List;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.annotation.XmlElementDecl;
import javax.xml.bind.annotation.XmlRegistry;
import javax.xml.namespace.QName;
import de.hft.stuttgart.citydoctor.datastructure.Geometry.LOD;


/**
 * This object contains factory methods for each 
 * Java content interface and Java element interface 
 * generated in the eu.simstadt.ade.energy package. 
 * <p>An ObjectFactory allows you to programatically 
 * construct new instances of the Java representation 
 * for XML content. The Java representation of XML 
 * content can consist of schema derived interfaces 
 * and classes representing the binding of schema 
 * type definitions, element declarations and model 
 * groups.  Factory methods for each of these are 
 * provided in this class.
 * 
 */
@XmlRegistry
public class ObjectFactory {

    private final static QName _SpatialProperties_QNAME = new QName("http://simstadt.eu/ade/energy", "spatialProperties");
    private final static QName _ThermalBoundaryAreaBelowGround_QNAME = new QName("http://simstadt.eu/ade/energy", "thermalBoundaryAreaBelowGround");
    private final static QName _LOD_QNAME = new QName("http://simstadt.eu/ade/energy", "LOD");
    private final static QName _ThermalBoundaryAreaAboveGround_QNAME = new QName("http://simstadt.eu/ade/energy", "thermalBoundaryAreaAboveGround");
    private final static QName _ExteriorSurfaceArea_QNAME = new QName("http://simstadt.eu/ade/energy", "exteriorSurfaceArea");
    private final static QName _PhysicsProperties_QNAME = new QName("http://simstadt.eu/ade/energy", "physicsProperties");
    private final static QName _SharedSurfaceArea_QNAME = new QName("http://simstadt.eu/ade/energy", "sharedSurfaceArea");
    private final static QName _ShortWaveIrradiance_QNAME = new QName("http://simstadt.eu/ade/energy", "shortWaveIrradiance");
    private final static QName _Azimuth_QNAME = new QName("http://simstadt.eu/ade/energy", "azimuth");
    private final static QName _ShellProperties_QNAME = new QName("http://simstadt.eu/ade/energy", "shellProperties");
    private final static QName _UsageZoneList_QNAME = new QName("http://simstadt.eu/ade/energy", "usageZoneList");
    private final static QName _Inclination_QNAME = new QName("http://simstadt.eu/ade/energy", "inclination");
    private final static QName _EndUse_QNAME = new QName("http://simstadt.eu/ade/energy", "endUse");

    /**
     * Create a new ObjectFactory that can be used to create new instances of schema derived classes for package: eu.simstadt.ade.energy
     * 
     */
    public ObjectFactory() {
    }

    /**
     * Create an instance of {@link UsageZoneList }
     * 
     */
    public UsageZoneList createUsageZoneList() {
        return new UsageZoneList();
    }

    /**
     * Create an instance of {@link ShellProperties }
     * 
     */
    public ShellProperties createShellProperties() {
        return new ShellProperties();
    }

    /**
     * Create an instance of {@link PhysicsProperties }
     * 
     */
    public PhysicsProperties createPhysicsProperties() {
        return new PhysicsProperties();
    }

    /**
     * Create an instance of {@link EndUse }
     * 
     */
    public EndUse createEndUse() {
        return new EndUse();
    }

    /**
     * Create an instance of {@link SpatialProperties }
     * 
     */
    public SpatialProperties createSpatialProperties() {
        return new SpatialProperties();
    }

    /**
     * Create an instance of {@link EnergyGenerationSystem }
     * 
     */
    public EnergyGenerationSystem createEnergyGenerationSystem() {
        return new EnergyGenerationSystem();
    }

    /**
     * Create an instance of {@link UsageZone }
     * 
     */
    public UsageZone createUsageZone() {
        return new UsageZone();
    }

    /**
     * Create an instance of {@link Fuel }
     * 
     */
    public Fuel createFuel() {
        return new Fuel();
    }

    /**
     * Create an instance of {@link Coord3 }
     * 
     */
    public Coord3 createCoord3() {
        return new Coord3();
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link SpatialProperties }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://simstadt.eu/ade/energy", name = "spatialProperties", substitutionHeadNamespace = "http://www.opengis.net/citygml/building/1.0", substitutionHeadName = "_GenericApplicationPropertyOfAbstractBuilding")
    public JAXBElement<SpatialProperties> createSpatialProperties(SpatialProperties value) {
        return new JAXBElement<SpatialProperties>(_SpatialProperties_QNAME, SpatialProperties.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Double }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://simstadt.eu/ade/energy", name = "thermalBoundaryAreaBelowGround", substitutionHeadNamespace = "http://www.opengis.net/citygml/building/1.0", substitutionHeadName = "_GenericApplicationPropertyOfBoundarySurface")
    public JAXBElement<Double> createThermalBoundaryAreaBelowGround(Double value) {
        return new JAXBElement<Double>(_ThermalBoundaryAreaBelowGround_QNAME, Double.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link LOD }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://simstadt.eu/ade/energy", name = "LOD", substitutionHeadNamespace = "http://www.opengis.net/citygml/building/1.0", substitutionHeadName = "_GenericApplicationPropertyOfAbstractBuilding")
    public JAXBElement<LOD> createLOD(LOD value) {
        return new JAXBElement<LOD>(_LOD_QNAME, LOD.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Double }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://simstadt.eu/ade/energy", name = "thermalBoundaryAreaAboveGround", substitutionHeadNamespace = "http://www.opengis.net/citygml/building/1.0", substitutionHeadName = "_GenericApplicationPropertyOfBoundarySurface")
    public JAXBElement<Double> createThermalBoundaryAreaAboveGround(Double value) {
        return new JAXBElement<Double>(_ThermalBoundaryAreaAboveGround_QNAME, Double.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Double }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://simstadt.eu/ade/energy", name = "exteriorSurfaceArea", substitutionHeadNamespace = "http://www.opengis.net/citygml/building/1.0", substitutionHeadName = "_GenericApplicationPropertyOfBoundarySurface")
    public JAXBElement<Double> createExteriorSurfaceArea(Double value) {
        return new JAXBElement<Double>(_ExteriorSurfaceArea_QNAME, Double.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link PhysicsProperties }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://simstadt.eu/ade/energy", name = "physicsProperties", substitutionHeadNamespace = "http://www.opengis.net/citygml/building/1.0", substitutionHeadName = "_GenericApplicationPropertyOfAbstractBuilding")
    public JAXBElement<PhysicsProperties> createPhysicsProperties(PhysicsProperties value) {
        return new JAXBElement<PhysicsProperties>(_PhysicsProperties_QNAME, PhysicsProperties.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Double }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://simstadt.eu/ade/energy", name = "sharedSurfaceArea", substitutionHeadNamespace = "http://www.opengis.net/citygml/building/1.0", substitutionHeadName = "_GenericApplicationPropertyOfBoundarySurface")
    public JAXBElement<Double> createSharedSurfaceArea(Double value) {
        return new JAXBElement<Double>(_SharedSurfaceArea_QNAME, Double.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link List }{@code <}{@link Integer }{@code >}{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://simstadt.eu/ade/energy", name = "shortWaveIrradiance", substitutionHeadNamespace = "http://www.opengis.net/citygml/building/1.0", substitutionHeadName = "_GenericApplicationPropertyOfBoundarySurface")
    public JAXBElement<List<Integer>> createShortWaveIrradiance(List<Integer> value) {
        return new JAXBElement<List<Integer>>(_ShortWaveIrradiance_QNAME, ((Class) List.class), null, ((List<Integer> ) value));
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Integer }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://simstadt.eu/ade/energy", name = "azimuth", substitutionHeadNamespace = "http://www.opengis.net/citygml/building/1.0", substitutionHeadName = "_GenericApplicationPropertyOfBoundarySurface")
    public JAXBElement<Integer> createAzimuth(Integer value) {
        return new JAXBElement<Integer>(_Azimuth_QNAME, Integer.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link ShellProperties }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://simstadt.eu/ade/energy", name = "shellProperties", substitutionHeadNamespace = "http://www.opengis.net/citygml/building/1.0", substitutionHeadName = "_GenericApplicationPropertyOfBoundarySurface")
    public JAXBElement<ShellProperties> createShellProperties(ShellProperties value) {
        return new JAXBElement<ShellProperties>(_ShellProperties_QNAME, ShellProperties.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link UsageZoneList }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://simstadt.eu/ade/energy", name = "usageZoneList", substitutionHeadNamespace = "http://www.opengis.net/citygml/building/1.0", substitutionHeadName = "_GenericApplicationPropertyOfAbstractBuilding")
    public JAXBElement<UsageZoneList> createUsageZoneList(UsageZoneList value) {
        return new JAXBElement<UsageZoneList>(_UsageZoneList_QNAME, UsageZoneList.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link Integer }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://simstadt.eu/ade/energy", name = "inclination", substitutionHeadNamespace = "http://www.opengis.net/citygml/building/1.0", substitutionHeadName = "_GenericApplicationPropertyOfBoundarySurface")
    public JAXBElement<Integer> createInclination(Integer value) {
        return new JAXBElement<Integer>(_Inclination_QNAME, Integer.class, null, value);
    }

    /**
     * Create an instance of {@link JAXBElement }{@code <}{@link EndUse }{@code >}}
     * 
     */
    @XmlElementDecl(namespace = "http://simstadt.eu/ade/energy", name = "endUse", substitutionHeadNamespace = "http://www.opengis.net/citygml/building/1.0", substitutionHeadName = "_GenericApplicationPropertyOfAbstractBuilding")
    public JAXBElement<EndUse> createEndUse(EndUse value) {
        return new JAXBElement<EndUse>(_EndUse_QNAME, EndUse.class, null, value);
    }

}
